/* 
   This code accompanies the paper `Exchanging Sources Between Clean and Haskell 
   - A Double-Edged Front End for the Clean Compiler' by John van Groningen, 
   Thomas van Noort, Peter Achten, Pieter Koopman, and Rinus Plasmeijer, 
   submitted to the Haskell Symposium 2010. 
   
   Disclaimer: The implementation of the front end is work in progress. This 
   beta release is far from complete and is not fully tested.
*/
implementation module Clean10Arrays

import StdEnv


zeroes :: Int -> .(a Int) | Array a Int
zeroes n = createArray n 0

fibs10 ::        .(a Int) | Array a Int
fibs10 = {1, 1, 2, 3, 5, 8, 13, 21, 34, 55}

fibs   :: Int -> .(a Int) | Array a Int
fibs n = {fib i \\ i <- [0..n - 1]}

fib :: !Int -> Int
fib 0 = 1
fib 1 = 1
fib n = fib (n - 1) + fib (n - 2)

fibs2 :: Int -> {Int}
fibs2 n = a
  where a = {createArray n 1 &  [i] = a.[i - 1] + a.[i - 2] 
                             \\ i <- [2..n - 1]}

isPalindrome :: {e} -> Bool | Eq e
isPalindrome a = size a <= 1 || check (0, size a - 1) a
  where check (i, j) a=:{[i] = x, [j] = y} =
          i >= j || x == y && check (i + 1, j - 1) a