/* 
   This code accompanies the paper `Exchanging Sources Between Clean and Haskell 
   - A Double-Edged Front End for the Clean Compiler' by John van Groningen, 
   Thomas van Noort, Peter Achten, Pieter Koopman, and Rinus Plasmeijer, 
   submitted to the Haskell Symposium 2010. 
   
   Disclaimer: The implementation of the front end is work in progress. This 
   beta release is far from complete and is not fully tested.
*/
implementation module Clean11DynamicTyping

import StdMaybe
import StdEnv


wrapInt :: Int -> Dynamic
wrapInt x = dynamic x :: Int

unwrapInt :: Dynamic -> Int
unwrapInt (x      :: Int)           = x
unwrapInt (xs     :: [a])           = length xs
unwrapInt ((f, x) :: (a -> Int, a)) = f x
unwrapInt (f :: A.a: [a] -> Int)    = f [1..10]
unwrapInt _                         = 10

wrapC :: a -> Dynamic | TC a
wrapC x = dynamic x

unwrapC :: Dynamic -> Maybe a | TC a
unwrapC (x :: a^) = Just x
unwrapC _         = Nothing