/* 
   This code accompanies the paper `Exchanging Sources Between Clean and Haskell 
   - A Double-Edged Front End for the Clean Compiler' by John van Groningen, 
   Thomas van Noort, Peter Achten, Pieter Koopman, and Rinus Plasmeijer, 
   submitted to the Haskell Symposium 2010. 
   
   Disclaimer: The implementation of the front end is work in progress. This 
   beta release is far from complete and is not fully tested.
*/
implementation module Clean12GenericFunctions

import Clean3Functions
import Clean6TypeClasses
import Clean9Records
import Haskell12GenericFunctions

import StdGeneric
import StdEnv


generic geqC a :: a a -> Bool
geqC{|Int|}          x            y            = eqC x y
geqC{|UNIT|}         UNIT         UNIT         = True
geqC{|EITHER|} fx _  (LEFT  x1)   (LEFT  x2)   = fx x1 x2
geqC{|EITHER|} _  fy (RIGHT y1)   (RIGHT y2)   = fy y1 y2
geqC{|EITHER|} fx fy _            _            = False
geqC{|PAIR|}   fx fy (PAIR x1 y1) (PAIR x2 y2) = fx x1 x2 && fy y1 y2
geqC{|CONS|}   f     (CONS x)     (CONS y)     = f x y
geqC{|FIELD|}  f     (FIELD x)    (FIELD y)    = f x y
geqC{|OBJECT|} f     (OBJECT x)   (OBJECT y)   = f x y

derive geqC [], GenTreeC, StreamC

instance EqC (GenTreeC a) | geqC{|*|} a where
  eqC x y = geqC{|*|} x y
