/* 
   This code accompanies the paper `Exchanging Sources Between Clean and Haskell 
   - A Double-Edged Front End for the Clean Compiler' by John van Groningen, 
   Thomas van Noort, Peter Achten, Pieter Koopman, and Rinus Plasmeijer, 
   submitted to the Haskell Symposium 2010. 
   
   Disclaimer: The implementation of the front end is work in progress. This 
   beta release is far from complete and is not fully tested.
*/
implementation module Clean9Records

import Haskell9Records

import StdEnv


:: GenTreeC a = {elt :: a, kids :: [GenTreeC a]}
:: StreamC  a = {elt :: a, str  :: StreamC a}

updStreamC :: Int a (StreamC a) -> StreamC a
updStreamC i x s=:{elt, str}
  | i < 0     = s
  | i == 0    = {StreamC | s & elt = x}
  | otherwise = {s & str = updStreamC (i - 1) x str}

mkStreamC :: StreamH Int
mkStreamC = StreamH 0 mkStreamC

hdStreamC :: (StreamH a) -> a
hdStreamC s = elt s