{- 
   This code accompanies the paper `Exchanging Sources Between Clean and Haskell 
   - A Double-Edged Front End for the Clean Compiler' by John van Groningen, 
   Thomas van Noort, Peter Achten, Pieter Koopman, and Rinus Plasmeijer, 
   submitted to the Haskell Symposium 2010. 
   
   Disclaimer: The implementation of the front end is work in progress. This 
   beta release is far from complete and is not fully tested.
-}
module Haskell12GenericFunctions where

import Clean6TypeClasses

import StdGeneric

 
data BinTree a = Leaf a | Node (BinTree a) a (BinTree a) 

`generic geqH a :: a a -> Bool
geqH{|Int|}          x            y            = eqC x y
geqH{|UNIT|}         UNIT         UNIT         = True
geqH{|EITHER|} fx _  (LEFT  x1)   (LEFT  x2)   = fx x1 x2
geqH{|EITHER|} _  fy (RIGHT y1)   (RIGHT y2)   = fy y1 y2
geqH{|EITHER|} fx fy _            _            = False
geqH{|PAIR|}   fx fy (PAIR x1 y1) (PAIR x2 y2) = fx x1 x2 && fy y1 y2
geqH{|CONS|}   f     (CONS x)     (CONS y)     = f x y
geqH{|FIELD|}  f     (FIELD x)    (FIELD y)    = f x y
geqH{|OBJECT|} f     (OBJECT x)   (OBJECT y)   = f x y

`derive geqH BinTree
