{- 
   This code accompanies the paper `Exchanging Sources Between Clean and Haskell 
   - A Double-Edged Front End for the Clean Compiler' by John van Groningen, 
   Thomas van Noort, Peter Achten, Pieter Koopman, and Rinus Plasmeijer, 
   submitted to the Haskell Symposium 2010. 
   
   Disclaimer: The implementation of the front end is work in progress. This 
   beta release is far from complete and is not fully tested.
-}
module Haskell7UniquenessTyping where

import Utility

import StdFile


writeLines :: Show a => [a] -> *File -> *File
writeLines [] file     = file
writeLines (x:xs) file = 
  writeLines xs (fwrites (clstring (show x)) file)

updateAtH :: (Num n) => n -> .a -> u:[.a] -> u:[.a]
updateAtH _ _ []     = []
updateAtH 0 x (_:ys) = x : ys
updateAtH n x (y:ys) = y : updateAtH (n - 1) x ys

swapAtH :: Int -> .b -> u:[.b] -> (.b, v:[.b]), [u <= v]
swapAtH _ x []     = (x, [])
swapAtH 0 x (y:ys) = (y, x:ys)
swapAtH n x (y:ys) = (z, y:zs)
  where (z, zs) = swapAtH (n - 1) x ys
