{- 
   This code accompanies the paper `Exchanging Sources Between Clean and Haskell 
   - A Double-Edged Front End for the Clean Compiler' by John van Groningen, 
   Thomas van Noort, Peter Achten, Pieter Koopman, and Rinus Plasmeijer, 
   submitted to the Haskell Symposium 2010. 
   
   Disclaimer: The implementation of the front end is work in progress. This 
   beta release is far from complete and is not fully tested.
-}
module Haskell8Monads where

newtype StateF s b = StateF (s -> (b, s))

instance Monad (StateF s) where
  return x = StateF (\s -> (x, s))
  (StateF f) >>= g
           = StateF (\s -> let (x, s1) = f s
                               (StateF h) = g x
                            in h s1
                    )
  f >> g   = f >>= const g
  fail     = error

mapSMH :: Monad m => (a -> m b) -> [a] -> m [b]
mapSMH f []     = return []
mapSMH f (x:xs) = do y  <- f x
                     ys <- mapSMH f xs
                     return (y:ys)