{- 
   This code accompanies the paper `Exchanging Sources Between Clean and Haskell 
   - A Double-Edged Front End for the Clean Compiler' by John van Groningen, 
   Thomas van Noort, Peter Achten, Pieter Koopman, and Rinus Plasmeijer, 
   submitted to the Haskell Symposium 2010. 
   
   Disclaimer: The implementation of the front end is work in progress. This 
   beta release is far from complete and is not fully tested.
-}
module Main where

import Clean3Functions, Haskell3Functions
import Clean4Macros, Haskell4Macros
import Clean5Newtypes, Haskell5Newtypes
import Clean6TypeClasses, Haskell6TypeClasses
import Clean7UniquenessTyping, Haskell7UniquenessTyping
import Clean8Monads, Haskell8Monads
import Clean9Records, Haskell9Records
import Clean10Arrays, Haskell10Arrays
import Clean11DynamicTyping, Haskell11DynamicTyping
import Clean12GenericFunctions, Haskell12GenericFunctions
import Utility

import Prelude hiding (Eq (..), Monad (return, (>>=)))
import StdMaybe hiding (Maybe (..))


main :: IO ()
main =
  do print "3.  Functions:         " (concatMap2C (take 10) [fibsC, fibsH])
     print "4.  Macros:            " (doubleC 1, doubleH 1)
     print "5.  Newtypes:          " (helloNat (NatH undefined))
     print "6.  Type classes:      " (eqLC [1..10] [1..11])
     print "7.  Uniqueness typing: " (mapS (\x s -> (x, (x:s))) [1..10] [])
     print "8.  Monads:            " (let (StateF f) = mapSMH (\x -> StateF (\s -> (x, (x:s)))) [1..10] in f [])
     print "9.  Records:           " (rootGenTreeH mkGenTreeH)
     print "10. Arrays:            " (isPalindrome (fibs2 10))
     print "11. Dynamic typing:    " ((unwrapH (wrapInt 1)) :: Maybe Int)
     print "12. Generic functions: " (geqC{|*|} (mkGenTreeH) {elt = 1, kids = []})

print :: Show a => String -> a -> IO ()
print s = putStrLn . (s++) . show

instance Show {#Char} where
  show = hstring