definition module Array where

from PreludeTypes import class Functor,class Eq,class Ord,class Show,class Read
import Ix

:: Array a b

array :: (Ix a) => !(!a,!a) -> ![(a,b)] -> Array a b special a=Int:==array`Int
array`Int :: !(!Int,!Int) -> ![(Int,b)] -> Array Int b
listArray :: (Ix a) => !(!a,!a) -> ![b] -> Array a b special a=Int
(!) infixl 9 :: (Ix a) => !(Array a b) -> a -> b special a=Int:==subscript`Int
subscript`Int :: !(Array Int b) -> !Int -> b
bounds :: (Ix a) => !Array a b -> (!a,!a) special a=Int
indices :: (Ix a) => !(Array a b) -> [a] special a=Int
elems :: (Ix a) => !(Array a b) -> [b] special a=Int
assocs :: (Ix a) => !(Array a b) -> [(a,b)] special a=Int:==assocs`Int
assocs`Int :: !(Array Int b) -> [(Int,b)]
// (/&/) infixl 9 :: (Ix a) => Array a b -> [(a,b)] -> Array a b
accum :: (Ix a) => (b -> c -> b) -> !(Array a b) -> ![(a,c)] -> Array a b special a=Int:==accum`Int
accum`Int :: (b -> c -> b) -> !(Array Int b) -> ![(Int,c)] -> Array Int b
accumArray :: (Ix a) => (b -> c -> b) -> b -> !(!a,!a) -> ![(a,c)] -> Array a b special a=Int:==accumArray`Int
accumArray`Int :: (b -> c -> b) -> b -> !(!Int,!Int) -> ![(Int,c)] -> Array Int b
(/&/) infixl 9 :: (Ix a) => !(Array a b) -> ![(a,b)] -> Array a b special a=Int:==updateArray`Int
updateArray`Int :: !(Array Int b) -> ![(Int,b)] -> Array Int b
ixmap :: (Ix a, Ix b) => !(!a,!a) -> (a -> b) -> Array b c -> Array a c special a=Int,b=Int:==ixmap`IntInt
ixmap`IntInt :: !(!Int,!Int) -> (Int -> Int) -> Array Int c -> Array Int c
instance (Ix a) => Functor (Array a) where
	fmap :: (Ix i) => (a -> b) -> !(Array i a) -> Array i b special i=Int
instance (Ix a, Eq b) => Eq (Array a b)
instance  (Ix a, Ord b) => Ord (Array a b)
instance  (Ix a, Show a, Show b) => Show (Array a b)
instance (Ix a, Read a, Read b) => Read (Array a b)
