definition module Data.Array.MArray where

from Prelude import class Monad
from PreludeTypes import qualified class Ord
from PreludeTypes import ::()
from Ix import class Ix,instance Ix Int

import Control.Monad.ST
import Data.Array.ST

class (Monad m) => MArray a e m where
	getBounds :: (Ix i) => a i e -> m (i, i)
    getNumElements :: (Ix i) => a i e -> m Int
	newArray :: (Ix i) => (i, i) -> e -> m (a i e)
	newArray_ :: (Ix i) => (i, i) -> m (a i e)
    unsafeNewArray_ :: (Ix i) => (i,i) -> m (a i e)
    unsafeRead  :: (Ix i) => a i e -> Int -> m e
    unsafeWrite :: (Ix i) => a i e -> Int -> e -> m ()

instance MArray (STArray s1) e (ST s2) where
	getBounds :: (Ix i) => STArray s1 i e -> ST s2 (i, i) special i=Int
    getNumElements :: (Ix i) => STArray s1 i e -> ST s2 Int special i=Int
	newArray_ :: (Ix i) => (i, i) -> ST s2 (STArray s1 i e) special i=Int
