implementation module Data.Array.MArray where

import Control.Monad.ST
import Data.Array.ST

class (Monad m) => MArray a e m where
	getBounds :: (Ix i) => a i e -> m (i, i)
    getNumElements :: (Ix i) => a i e -> m Int
	newArray :: (Ix i) => (i, i) -> e -> m (a i e)
	newArray_ :: (Ix i) => (i, i) -> m (a i e)
    unsafeNewArray_ :: (Ix i) => (i,i) -> m (a i e)
    unsafeRead  :: (Ix i) => a i e -> Int -> m e
    unsafeWrite :: (Ix i) => a i e -> Int -> e -> m ()

instance MArray (STArray s1) e (ST s2) where
	getBounds :: (Ix i) => STArray s1 i e -> ST s2 (i, i)
	getBounds arr = undefined
    getNumElements :: (Ix i) => STArray s1 i e -> ST s2 Int
	getNumElements arr = undefined // return $! ArrST.numElementsSTArray arr
	newArray _ _ = undefined // ArrST.newSTArray
	newArray_ :: (Ix i) => (i, i) -> ST s2 (STArray s1 i e)
	newArray_ b@(l,h) = ST newArray_st
		where
			newArray_st s
				#! a = STArray l h (createLazyArray_ (rangeSize b))
				= (s,a)
    unsafeNewArray_ _ = undefined
	unsafeRead _ _ = undefined // ArrST.unsafeReadSTArray
	unsafeWrite _ _ _ = undefined // ArrST.unsafeWriteSTArray

createLazyArray_ :: !Int -> *{e}
createLazyArray_ size = `code {	
		create_array_ _ 1 0
}
