definition module Directory

from PreludeTypes import qualified
  :: Ordering
 ,:: IO
 ,:: ()
 ,class Eq
 ,class Ord
 ,class Show
 ,class Read
from Time import qualified
  :: ClockTime
:: Permissions
 = Permissions { readable :: Bool,writable :: Bool,executable :: Bool,searchable :: Bool}
instance PreludeTypes.Eq Permissions where
  (/=) infix 4 :: !Permissions !Permissions -> Bool
  (==) infix 9 :: !Permissions !Permissions -> Bool
instance PreludeTypes.Ord Permissions where
  (<) infix 4 :: !Permissions !Permissions -> Bool
  (<=) infix 4 :: !Permissions !Permissions -> Bool
  (>) infix 4 :: !Permissions !Permissions -> Bool
  (>=) infix 4 :: !Permissions !Permissions -> Bool
  compare :: !Permissions !Permissions -> PreludeTypes.Ordering
  max :: !Permissions !Permissions -> Permissions
  min :: !Permissions !Permissions -> Permissions
instance PreludeTypes.Read Permissions where
  readList :: ([Char] -> [([Permissions],[Char])])
  readsOpenParensPrec :: Int ![Char] -> [[(Permissions,[Char])]]
  readsPrec :: Int -> [Char] -> [(Permissions,[Char])]
instance PreludeTypes.Show Permissions where
  show :: !Permissions -> [Char]
  showList :: ![Permissions] -> [Char] -> [Char]
  showsPrec :: !Int !Permissions -> [Char] -> [Char]
createDirectory :: [Char] -> PreludeTypes.IO PreludeTypes.`Unit
removeDirectory :: [Char] -> PreludeTypes.IO PreludeTypes.`Unit
removeFile :: [Char] -> PreludeTypes.IO PreludeTypes.`Unit
renameDirectory :: [Char] [Char] -> PreludeTypes.IO PreludeTypes.`Unit
renameFile :: [Char] [Char] -> PreludeTypes.IO PreludeTypes.`Unit
getDirectoryContents :: [Char] -> PreludeTypes.IO [[Char]]
getCurrentDirectory :: PreludeTypes.IO [Char]
setCurrentDirectory :: [Char] -> PreludeTypes.IO PreludeTypes.`Unit
doesDirectoryExist :: [Char] -> PreludeTypes.IO Bool
doesFileExist :: [Char] -> PreludeTypes.IO Bool
getModificationTime :: [Char] -> PreludeTypes.IO Time.ClockTime
getPermissions :: [Char] -> PreludeTypes.IO Permissions
setPermissions :: [Char] Permissions -> PreludeTypes.IO PreludeTypes.`Unit
