definition module Foreign.ForeignPtr

from PreludeTypes import qualified ::IO,class Eq,class Ord,class Show,::Ordering
from Foreign.Storable import qualified class Storable
from Foreign.Ptr import qualified ::Ptr

:: ForeignPtr a(:==Int)

mallocForeignPtrArray :: !Int -> PreludeTypes.IO (ForeignPtr a) | Foreign.Storable.Storable a
withForeignPtr :: !(ForeignPtr a) !((Foreign.Ptr.Ptr a) -> PreludeTypes.IO b) -> PreludeTypes.IO b

instance PreludeTypes.Eq (ForeignPtr a) where
	(==) :: !(ForeignPtr a) !(ForeignPtr a) -> Bool
	(/=) :: !(ForeignPtr a) !(ForeignPtr a) -> Bool

instance PreludeTypes.Ord (ForeignPtr a) where
	(<=) :: !(ForeignPtr a) !(ForeignPtr a) -> Bool
	(<)  :: !(ForeignPtr a) !(ForeignPtr a) -> Bool
	(>=) :: !(ForeignPtr a) !(ForeignPtr a) -> Bool
	(>)  :: !(ForeignPtr a) !(ForeignPtr a) -> Bool
	compare :: !(ForeignPtr a) !(ForeignPtr a) -> PreludeTypes.Ordering
	min  :: !(ForeignPtr a) !(ForeignPtr a) -> ForeignPtr a
	max  :: !(ForeignPtr a) !(ForeignPtr a) -> ForeignPtr a

instance PreludeTypes.Show (ForeignPtr a) where
	show :: !(ForeignPtr a) -> [Char]
