implementation module Foreign.ForeignPtr where

import Foreign.Storable
import Foreign.Ptr

import PreludeInternal (string_to_char_list,string_to_char_list_append)
from StdString import class toString (..),instance toString Int

type ForeignPtr a = Int

mallocForeignPtrArray :: (Storable a) => !Int -> IO (ForeignPtr a)
mallocForeignPtrArray _ = undefined

withForeignPtr :: !(ForeignPtr a) -> !(Ptr a -> IO b) -> IO b
withForeignPtr fp f = undefined

instance Eq (ForeignPtr a) where
	(==) :: !(ForeignPtr a) -> !(ForeignPtr a) -> Bool
	p1 == p2 = `code {
		eqI
	 }
	(/=) :: !(ForeignPtr a) -> !(ForeignPtr a) -> Bool
	p1 /= p2 = `code {
		eqI
		notB
	 }

instance Ord (ForeignPtr a) where
	compare :: !(ForeignPtr a) -> !(ForeignPtr a) -> Ordering
	compare a b
		= if a==b
		  then EQ
		  else  if a<b
				then LT
				else GT

	(<=) infix 4 :: !(ForeignPtr a) -> !(ForeignPtr a) -> Bool
	x <= y = `code inline {
				gtU
				notB
			}

	(<) infix  4 :: !(ForeignPtr a) -> !(ForeignPtr a) -> Bool
	x < y  = `code inline {
				ltU
			}

	(>=) infix 4 :: !(ForeignPtr a) -> !(ForeignPtr a) -> Bool
	x >= y = `code inline {
				ltU
				notB
			}

	(>) infix  4 :: !(ForeignPtr a) -> !(ForeignPtr a) -> Bool
	x > y  = `code inline {
				gtU
			} 

	min :: !(ForeignPtr a) -> !(ForeignPtr a) -> ForeignPtr a
	min x y  = `code inline {
				.newlocallabel _ForeignPtr_min
				push_b 1
				push_b 1
				ltU
				jmp_false _ForeignPtr_min
				update_b 0 1
			:_ForeignPtr_min
				pop_b 1
			}

	max :: !(ForeignPtr a) -> !(ForeignPtr a) -> ForeignPtr a
	max x y = `code inline {
				.newlocallabel _ForeignPtr_max
				push_b 1
				push_b 1
				gtU
				jmp_false _ForeignPtr_max
				update_b 0 1
			:_ForeignPtr_max
				pop_b 1
			}

instance Show (ForeignPtr a) where
	show :: !(ForeignPtr a) -> [Char]
	--to do: fix if > max int
	show i = string_to_char_list (toString i)
	showsPrec _ i = string_to_char_list_append (toString i)
