implementation module Foreign.Marshal.Alloc where

import Prelude
import Data.Bits
import Foreign.Ptr,Foreign.Storable

allocaBytes :: !Int -> !((Ptr a) -> IO b) -> IO b
allocaBytes n f
	= IO (\w -> alloca_bytes n f w);

alloca_bytes :: !Int -> !((Ptr a) -> IO b) -> !*World -> *(b,*World)
alloca_bytes n f w
	= `code {
		pushI 3
		addI
		pushI -4
		and%
	:alloca_bytes_0
		instruction 41	| subl %eax,%esp
		instruction 196
		instruction 80	| push %eax
		instruction	137	| movl %esp,%eax
		instruction 224
	:alloca_bytes_1
		pushI 4
		addI
		buildI_b 0
		pop_b 1
		push_a 1
		update_a 1 2
		update_a 0 1
		pop_a 1
		jsr_ap 2
	:alloca_bytes_2
		instruction 88	| pop %eax
		instruction 1	| addl %eax,%esp
		instruction 196
	:alloca_bytes_3
		repl_args 2 2
	}

alloca :: !(Ptr a -> IO b) -> IO b | Storable a
alloca f
	#! a=a
	#! (a,f) = (a,f) :: (a,(Ptr a) -> IO b);
	= allocaBytes (sizeOf a) f
 where	
	a :: a
	a = `code inline {
		buildh _Nil 0
	 }
