definition module Foreign.Ptr

from PreludeTypes import qualified class Eq,class Ord,class Show,
	::Ordering,::(),::IO

:: Ptr a(:==Int)
:: FunPtr a(:==Int)

castPtr :: !(Ptr a) -> Ptr b
nullPtr :: Ptr a
plusPtr :: !(Ptr a) !Int -> Ptr b

nullFunPtr :: FunPtr a

freeHaskellFunPtr :: !(FunPtr a) -> PreludeTypes.IO PreludeTypes.`Unit

instance PreludeTypes.Eq (Ptr a) where
	(==) :: !(Ptr a) !(Ptr a) -> Bool
	(/=) :: !(Ptr a) !(Ptr a) -> Bool

instance PreludeTypes.Eq (FunPtr a) where
	(==) :: !(FunPtr a) !(FunPtr a) -> Bool
	(/=) :: !(FunPtr a) !(FunPtr a) -> Bool

instance PreludeTypes.Ord (Ptr a) where
	compare :: !(Ptr a) !(Ptr a) -> PreludeTypes.Ordering
	(<=) infix 4 :: !(Ptr a) !(Ptr a) -> Bool
	(<) infix  4 :: !(Ptr a) !(Ptr a) -> Bool
	(>=) infix 4 :: !(Ptr a) !(Ptr a) -> Bool
	(>) infix  4 :: !(Ptr a) !(Ptr a) -> Bool
	min :: !(Ptr a) !(Ptr a) -> (Ptr a)
	max :: !(Ptr a) !(Ptr a) -> (Ptr a)

instance PreludeTypes.Show (Ptr a) where
	show :: !(Ptr a) -> [Char]

w`peek_ptr :: !(Ptr (Ptr a)) !*World -> (!Ptr a,!*World);
w`poke_ptr :: !(Ptr (Ptr a)) !(Ptr a) !*World -> (!PreludeTypes.`Unit,!*World)
w`peek_elem_off_ptr :: !(Ptr (Ptr a)) !Int !*World -> (!Ptr a,!*World);
w`poke_elem_off_ptr :: !(Ptr (Ptr a)) !Int !(Ptr a) !*World -> (!PreludeTypes.`Unit,!*World)
w`peek_byte_off_ptr :: !(Ptr (Ptr a)) !Int !*World -> (!(Ptr a),!*World);
w`poke_byte_off_ptr :: !(Ptr (Ptr a)) !Int !(Ptr a) !*World -> (!PreludeTypes.`Unit,!*World)
