implementation module Foreign.Ptr

import PreludeTypes
from PreludeTypes import qualified ::()
import PreludeInternal
from StdString import class toString (..),instance toString Int
from Prelude import undefined

// import functions used by ffi wrappers
from Foreign.StablePtr import allocate_fun_wrapper`,deRefStablePtr`,::StablePtr
from System.IO.Unsafe import unsafePerformIO

:: Ptr a:==Int
:: FunPtr a:==Int

castPtr :: !(Ptr a) -> Ptr b
castPtr p = code inline {
	pop_b 0
 }

nullPtr :: Ptr a
nullPtr = 0

plusPtr :: !(Ptr a) !Int -> Ptr b
plusPtr p i = code {
	addI
}

nullFunPtr :: FunPtr a
nullFunPtr = 0

freeHaskellFunPtr :: !(FunPtr a) -> IO PreludeTypes.`Unit
freeHaskellFunPtr _ = undefined

instance Eq (Ptr a) where
	(==) :: !(Ptr a) !(Ptr a) -> Bool
	(==) p1 p2 = code inline {
		eqI
	 }
	(/=) :: !(Ptr a) !(Ptr a) -> Bool
	(/=) p1 p2 = code inline {
		eqI
		notB
	 }

instance Eq (FunPtr a) where
	(==) :: !(FunPtr a) !(FunPtr a) -> Bool
	(==) p1 p2 = code inline {
		eqI
	 }
	(/=) :: !(FunPtr a) !(FunPtr a) -> Bool
	(/=) p1 p2 = code inline {
		eqI
		notB
	 }

instance Ord (Ptr a) where
	compare :: !(Ptr a) !(Ptr a) -> Ordering
	compare a b
		= if (a==b)
		 	EQ
		  	(if (a<b)
				LT
				GT)

	(<=) infix 4 :: !(Ptr a) !(Ptr a) -> Bool
	x <= y = code inline {
				gtU
				notB
			}

	(<) infix  4 :: !(Ptr a) !(Ptr a) -> Bool
	x < y  = code inline {
				ltU
			}

	(>=) infix 4 :: !(Ptr a) !(Ptr a) -> Bool
	x >= y = code inline {
				ltU
				notB
			}

	(>) infix  4 :: !(Ptr a) !(Ptr a) -> Bool
	x > y  = code inline {
				gtU
			} 

	min :: !(Ptr a) !(Ptr a) -> (Ptr a)
	min x y  = code inline {
				.newlocallabel _Ptr_min
				push_b 1
				push_b 1
				ltU
				jmp_false _Ptr_min
				update_b 0 1
			:_Ptr_min
				pop_b 1
			}

	max :: !(Ptr a) !(Ptr a) -> (Ptr a)
	max x y = code inline {
				.newlocallabel _Ptr_max
				push_b 1
				push_b 1
				gtU
				jmp_false _Ptr_max
				update_b 0 1
			:_Ptr_max
				pop_b 1
			}

instance Show (Ptr a) where
	show :: !(Ptr a) -> [Char]
	//to do: fix if > max int
	show i = string_to_char_list (toString i)
	showsPrec _ i = string_to_char_list_append (toString i)

w`peek_ptr :: !(Ptr (Ptr a)) !*World -> (!Ptr a,!*World);
w`peek_ptr p w = code {
	load_i 0
 }

w`poke_ptr :: !(Ptr (Ptr a)) !(Ptr a) !*World -> (!PreludeTypes.`Unit,!*World)
w`poke_ptr p v w = code {
	:poke_ptr_0
	|	movl	%eax,(%ebx)
	instruction 137
	instruction 3
	:poke_ptr_1
	pop_b 2
	buildh e_PreludeTypes_d`Unit 0
 }

w`peek_elem_off_ptr :: !(Ptr (Ptr a)) !Int !*World -> (!Ptr a,!*World);
w`peek_elem_off_ptr p i w = code {
	pushI 2
	push_b 2
	shiftl%
	addI
	updatepop_b 0 1
	load_i 0
 }

w`poke_elem_off_ptr :: !(Ptr (Ptr a)) !Int !(Ptr a) !*World -> (!PreludeTypes.`Unit,!*World)
w`poke_elem_off_ptr p i v w = code {
	pushI 2
	push_b 2
	shiftl%
	addI
	updatepop_b 0 1
	.o 1 2 ii
	:poke_elem_off_ptr_0
	|	movl	%eax,(%ebx)
	instruction 137
	instruction 3
	:poke_elem_off_ptr_1
	pop_b 2
	buildh e_PreludeTypes_d`Unit 0
 }

w`peek_byte_off_ptr :: !(Ptr (Ptr a)) !Int !*World -> (!(Ptr a),!*World);
w`peek_byte_off_ptr p i w = code {
	addI
	load_i 0
 }

w`poke_byte_off_ptr :: !(Ptr (Ptr a)) !Int !(Ptr a) !*World -> (!PreludeTypes.`Unit,!*World)
w`poke_byte_off_ptr p i v w = code {
	addI
	.o 1 2 ii
	:poke_byte_off_ptr_0
	|	movl	%eax,(%ebx)
	instruction 137
	instruction 3
	:poke_byte_off_ptr_1
	pop_b 2
	buildh e_PreludeTypes_d`Unit 0
 }
