implementation module Foreign.StablePtr;

import Prelude;
from Foreign.Ptr import ::FunPtr;
import StdArray;

:: StablePtr p :== Int;

stable_ptr_array :: {a};
stable_ptr_array =: {};

deRefStablePtr :: (StablePtr a) -> IO a;
deRefStablePtr sp = IO (deRefStablePtr`world sp);

deRefStablePtr`world :: !(StablePtr a) !*World -> (a,!*World);
deRefStablePtr`world sp w
	#! (a,spa) = stable_ptr_array![sp]
	= (a,w);

deRefStablePtr` :: !(StablePtr a) -> a;
deRefStablePtr` sp
	#! (a,spa) = stable_ptr_array![sp]
	= a;

newStablePtr` :: a -> (StablePtr a);
newStablePtr` a = -1;

allocate_fun_wrapper` :: a !(FunPtr a) !*World -> (!FunPtr a,!*World);
allocate_fun_wrapper` a fp w
	# spa = newStablePtr` a
	= (fp,w);
