definition module IO hiding (
	Handle
  )

import PreludeIO
:: Handle
 =: Handle Int
:: IOMode
 = ReadMode 
 | WriteMode 
 | AppendMode 
 | ReadWriteMode 
:: HandlePosn
 = { hp_handle :: !Handle,hp_posn :: !Int }
:: SeekMode
 = AbsoluteSeek 
 | RelativeSeek 
 | SeekFromEnd 
instance Eq Handle where
  (/=) infix 4 :: !Handle !Handle -> Bool
  (==) infix 9 :: !Handle !Handle -> Bool
instance Eq IOMode where
  (/=) infix 4 :: !IOMode IOMode -> Bool
  (==) infix 9 :: !IOMode IOMode -> Bool
instance Ord IOMode where
  (<) infix 4 :: !IOMode !IOMode -> Bool
  (<=) infix 4 :: !IOMode !IOMode -> Bool
  (>) infix 4 :: !IOMode !IOMode -> Bool
  (>=) infix 4 :: !IOMode !IOMode -> Bool
  compare :: !IOMode !IOMode -> Ordering
  max :: !IOMode !IOMode -> IOMode
  min :: !IOMode !IOMode -> IOMode
instance Ix IOMode where
  inRange :: !(!IOMode,IOMode) !IOMode -> Bool
  index :: !(!IOMode,!IOMode) !IOMode -> Int
  range :: !(!IOMode,!IOMode) -> [IOMode]
  rangeSize :: !(!IOMode,!IOMode) -> Int
instance Bounded IOMode where
  maxBound :: IOMode
  minBound :: IOMode
instance Enum IOMode where
  enumFrom :: !IOMode -> [IOMode]
  enumFromThen :: !IOMode !IOMode -> [IOMode]
  enumFromThenTo :: !IOMode !IOMode !IOMode -> [IOMode]
  enumFromTo :: !IOMode !IOMode -> [IOMode]
  fromEnum :: !IOMode -> Int
  pred :: (IOMode -> IOMode)
  succ :: (IOMode -> IOMode)
  toEnum :: !Int -> IOMode
instance Read IOMode where
  readList :: ([Char] -> [([IOMode],[Char])])
  readsOpenParensPrec :: Int ![Char] -> [[(IOMode,[Char])]]
  readsPrec :: Int -> [Char] -> [(IOMode,[Char])]
instance Show IOMode where
  show :: !IOMode -> [Char]
  showList :: ![IOMode] -> [Char] -> [Char]
  showsPrec :: Int !IOMode -> [Char] -> [Char]
instance Eq SeekMode where
  (/=) infix 4 :: !SeekMode SeekMode -> Bool
  (==) infix 9 :: !SeekMode SeekMode -> Bool
instance Ord SeekMode where
  (<) infix 4 :: !SeekMode !SeekMode -> Bool
  (<=) infix 4 :: !SeekMode !SeekMode -> Bool
  (>) infix 4 :: !SeekMode !SeekMode -> Bool
  (>=) infix 4 :: !SeekMode !SeekMode -> Bool
  compare :: !SeekMode !SeekMode -> Ordering
  max :: !SeekMode !SeekMode -> SeekMode
  min :: !SeekMode !SeekMode -> SeekMode
instance Ix SeekMode where
  inRange :: !(!SeekMode,SeekMode) !SeekMode -> Bool
  index :: !(!SeekMode,!SeekMode) !SeekMode -> Int
  range :: !(!SeekMode,!SeekMode) -> [SeekMode]
  rangeSize :: !(!SeekMode,!SeekMode) -> Int
instance Bounded SeekMode where
  maxBound :: SeekMode
  minBound :: SeekMode
instance Enum SeekMode where
  enumFrom :: !SeekMode -> [SeekMode]
  enumFromThen :: !SeekMode !SeekMode -> [SeekMode]
  enumFromThenTo :: !SeekMode !SeekMode !SeekMode -> [SeekMode]
  enumFromTo :: !SeekMode !SeekMode -> [SeekMode]
  fromEnum :: !SeekMode -> Int
  pred :: (SeekMode -> SeekMode)
  succ :: (SeekMode -> SeekMode)
  toEnum :: !Int -> SeekMode
instance Read SeekMode where
  readList :: ([Char] -> [([SeekMode],[Char])])
  readsOpenParensPrec :: Int ![Char] -> [[(SeekMode,[Char])]]
  readsPrec :: Int -> [Char] -> [(SeekMode,[Char])]
instance Show SeekMode where
  show :: !SeekMode -> [Char]
  showList :: ![SeekMode] -> [Char] -> [Char]
  showsPrec :: Int !SeekMode -> [Char] -> [Char]
stderr :: Handle
stdin :: Handle
stdout :: Handle
openFile :: [Char] IOMode -> IO Handle
hClose :: Handle -> IO `Unit
hIsEOF :: Handle -> IO Bool
hGetChar :: Handle -> IO Char
hGetLine :: Handle -> IO [Char]
hGetContents :: Handle -> IO [Char]
hPutChar :: Handle Char -> IO `Unit
hPutStr :: Handle [Char] -> IO `Unit
hPutStrLn :: Handle [Char] -> IO `Unit
hGetPosn :: Handle -> IO HandlePosn
hSetPosn :: HandlePosn -> IO `Unit
hSeek :: Handle SeekMode Integer -> IO `Unit
isAlreadyExistsError :: !IOError -> Bool
isDoesNotExistError :: !IOError -> Bool
isPermissionError :: !IOError -> Bool
isEOFError :: !IOError -> Bool
isFullError :: !IOError -> Bool
isIllegalOperation :: !IOError -> Bool
isUserError :: !IOError -> Bool
ioeGetErrorString :: !IOError -> [Char]
try :: (IO a) -> IO (Either IOError a)
bracket :: (IO a) (a -> IO b) (a -> IO c) -> IO c
bracket_ :: (IO a) (a -> IO b) (IO c) -> IO c
