definition module Ix where

from PreludeTypes import class Ix(..),::Integer,::(),::Ordering
from PreludeTypes import qualified class Ord,class Num(+)

instance Ix Char where
	range :: !(Char,Char) -> [Char]
	index :: !(!Char,!Char) -> !Char -> Int
	inRange :: !(!Char,Char) -> !Char -> Bool
	rangeSize :: !(!Char,!Char) -> Int

instance Ix Int where
	range :: !(Int,Int) -> [Int]
	index :: !(!Int,!Int) -> !Int -> Int
	inRange :: !(!Int,!Int) -> !Int -> Bool
	rangeSize :: !(!Int,!Int) -> Int

instance Ix Integer where
	range :: !(Integer,Integer) -> [Integer]
	index :: !(!Integer,!Integer) -> !Integer -> Int
	inRange :: !(!Integer,Integer) -> !Integer -> Bool
	rangeSize :: !(!Integer,!Integer) -> Int

instance Ix Bool where
	range :: !(Bool,Bool) -> [Bool]
	index :: !(!Bool,!Bool) -> !Bool -> Int
	inRange :: !(!Bool,Bool) -> !Bool -> Bool
	rangeSize :: !(!Bool,!Bool) -> Int

instance Ix () where
	range :: !(!(),!()) -> [()]
	inRange :: !(!(),!()) -> !() -> Bool
	index :: !(!(),!()) -> !() -> Int
	rangeSize :: !(!(),!()) -> Int

instance Ix Ordering where
	range :: !(Ordering,Ordering) -> [Ordering]
	index :: !(!Ordering,!Ordering) -> !Ordering -> Int
	inRange :: !(!Ordering,Ordering) -> !Ordering -> Bool
	rangeSize :: !(!Ordering,!Ordering) -> Int

instance (Ix e0,Ix e1) => Ix (e0,e1) where
	range :: (Ix e0,Ix e1) => !(!(e0,e1),!(e0,e1)) -> [(e0,e1)] special e0=Int,e1=Int:==range`2tuple_int_int
	inRange :: (Ix e0,Ix e1) => !(!(e0,e1),!(e0,e1)) -> !(e0,e1) -> Bool special e0=Int,e1=Int:==inRange`2tuple_int_int
	index :: (Ix e0,Ix e1) => !(!(e0,e1),!(e0,e1)) -> !(e0,e1) -> Int special e0=Int,e1=Int:==index`2tuple_int_int
	rangeSize :: (Ix e0,Ix e1) => !(!(e0,e1),!(e0,e1)) -> Int special e0=Int,e1=Int:==rangeSize`2tuple_int_int

range`2tuple_int_int :: !(!(!Int,Int),!(!Int,Int)) -> [(Int,Int)]
inRange`2tuple_int_int :: !(!(!Int,!Int),!(!Int,!Int)) -> !(!Int,!Int) -> Bool
index`2tuple_int_int :: !(!(!Int,!Int),!(!Int,!Int)) -> !(!Int,!Int) -> Int
rangeSize`2tuple_int_int :: !(!(!Int,!Int),!(!Int,!Int)) -> Int

instance (Ix e0,Ix e1,Ix e2) => Ix (e0,e1,e2) where	
	range :: (Ix e0,Ix e1,Ix e2) => !(!(e0,e1,e2),!(e0,e1,e2)) -> [(e0,e1,e2)] special e0=Int,e1=Int,e2=Int:==range`3tuple_int_int
	inRange :: (Ix e0,Ix e1,Ix e2) => !(!(e0,e1,e2),!(e0,e1,e2)) -> !(e0,e1,e2) -> Bool special e0=Int,e1=Int,e2=Int:==inRange`3tuple_int_int
	index :: (Ix e0,Ix e1,Ix e2) => !(!(e0,e1,e2),!(e0,e1,e2)) -> !(e0,e1,e2) -> Int special e0=Int,e1=Int,e2=Int:==index`3tuple_int_int
	rangeSize :: (Ix e0,Ix e1,Ix e2) => !(!(e0,e1,e2),!(e0,e1,e2)) -> Int special e0=Int,e1=Int,e2=Int:==rangeSize`3tuple_int_int

range`3tuple_int_int :: !(!(!Int,Int,Int),!(!Int,Int,Int)) -> [(Int,Int,Int)]
inRange`3tuple_int_int :: !(!(!Int,!Int,!Int),!(!Int,!Int,!Int)) -> !(!Int,!Int,!Int) -> Bool
index`3tuple_int_int :: !(!(!Int,!Int,!Int),!(!Int,!Int,!Int)) -> !(!Int,!Int,!Int) -> Int
rangeSize`3tuple_int_int :: !(!(!Int,!Int,!Int),!(!Int,!Int,!Int)) -> Int

instance (Ix e0,Ix e1,Ix e2,Ix e3) => Ix (e0,e1,e2,e3) where
	range :: (Ix e0,Ix e1,Ix e2,Ix e3) => !(!(e0,e1,e2,e3),!(e0,e1,e2,e3)) -> [(e0,e1,e2,e3)]
	inRange :: (Ix e0,Ix e1,Ix e2,Ix e3) => !(!(e0,e1,e2,e3),!(e0,e1,e2,e3)) -> !(e0,e1,e2,e3) -> Bool
	index :: (Ix e0,Ix e1,Ix e2,Ix e3) => !(!(e0,e1,e2,e3),!(e0,e1,e2,e3)) -> !(e0,e1,e2,e3) -> Int
	rangeSize :: (Ix e0,Ix e1,Ix e2,Ix e3) => !(!(e0,e1,e2,e3),!(e0,e1,e2,e3)) -> Int

instance (Ix e0,Ix e1,Ix e2,Ix e3,Ix e4) => Ix (e0,e1,e2,e3,e4) where
	range :: (Ix e0,Ix e1,Ix e2,Ix e3,Ix e4) => !(!(e0,e1,e2,e3,e4),!(e0,e1,e2,e3,e4)) -> [(e0,e1,e2,e3,e4)]
	inRange :: (Ix e0,Ix e1,Ix e2,Ix e3,Ix e4) => !(!(e0,e1,e2,e3,e4),!(e0,e1,e2,e3,e4)) -> !(e0,e1,e2,e3,e4) -> Bool
	index :: (Ix e0,Ix e1,Ix e2,Ix e3,Ix e4) => !(!(e0,e1,e2,e3,e4),!(e0,e1,e2,e3,e4)) -> !(e0,e1,e2,e3,e4) -> Int
	rangeSize :: (Ix e0,Ix e1,Ix e2,Ix e3,Ix e4) => !(!(e0,e1,e2,e3,e4),!(e0,e1,e2,e3,e4)) -> Int
