definition module Numeric where

from PreludeTypes import
	::Float,::Integer,::Maybe,class RealFloat,class Real,class Integral,class RealFrac
from PreludeTypes import qualified
	::Rational,::ShowS,::ReadS,
	class Floating,class RealFrac,class Ord,class Num,class Enum,class Fractional

fromRat :: (RealFloat a) => !PreludeTypes.Rational -> a
			special a=Double:==fromRat`Double;a=Float:==fromRat`Float
fromRat`Double :: !PreludeTypes.Rational -> Double
fromRat`Float :: !PreludeTypes.Rational -> Float
showSigned :: (Real a) => (a -> PreludeTypes.ShowS) -> Int -> a -> PreludeTypes.ShowS
showOct :: (Integral a) => a -> PreludeTypes.ShowS special a=Int
showInt :: (Integral a) => a -> PreludeTypes.ShowS special a=Int
showHex :: (Integral a) => a -> PreludeTypes.ShowS special a=Int
showIntAtBase :: (Integral a) => a -> (Int -> Char) -> a -> [Char] -> [Char]
readSigned :: (Real a) => PreludeTypes.ReadS a -> PreludeTypes.ReadS a
readInt :: (Integral a) => a -> (Char -> Bool) -> (Char -> Int) -> ![Char] -> [(a,[Char])]
readDec :: (Integral a) => PreludeTypes.ReadS a
readOct :: (Integral a) => PreludeTypes.ReadS a
readHex :: (Integral a) => PreludeTypes.ReadS a

showFloat :: (RealFloat a) => a -> PreludeTypes.ShowS
			special a=Double:==showFloat`Double;a=Float:==showFloat`Float
showFloat`Double :: !Double -> PreludeTypes.ShowS
showFloat`Float :: !Float -> PreludeTypes.ShowS

showEFloat :: (RealFloat a) => Maybe Int -> a -> PreludeTypes.ShowS
			special a=Double:==showEFloat`Double;a=Float:==showEFloat`Float
showEFloat`Double :: Maybe Int -> !Double -> PreludeTypes.ShowS
showEFloat`Float :: Maybe Int -> !Float -> PreludeTypes.ShowS

showFFloat :: (RealFloat a) => Maybe Int -> a -> PreludeTypes.ShowS
			special a=Double:==showFFloat`Double;a=Float:==showFFloat`Float
showFFloat`Double :: Maybe Int -> !Double -> PreludeTypes.ShowS
showFFloat`Float :: Maybe Int -> !Float -> PreludeTypes.ShowS

showGFloat :: (RealFloat a) => Maybe Int -> a -> PreludeTypes.ShowS
			special a=Double:==showGFloat`Double;a=Float:==showGFloat`Float
showGFloat`Double :: Maybe Int -> !Double -> PreludeTypes.ShowS
showGFloat`Float :: Maybe Int -> !Float -> PreludeTypes.ShowS

floatToDigits :: (RealFloat a) => Integer -> a -> ([Int], Int)
	special a=Double:==floatToDigits`Double;a=Float:==floatToDigits`Float
floatToDigits`Double :: Integer -> !Double -> ([Int], Int)
floatToDigits`Float :: Integer -> !Float -> ([Int], Int)

readFloat :: ![Char] -> [(a,[Char])] | RealFrac a
lexDigits :: ![Char] -> [([Char],[Char])]
