definition module PreludeFloat where

import PreludeTypes

instance Real Double where
	toRational :: !Double -> Rational

instance Real Float where
	toRational :: !Float -> Rational

instance RealFloat Double where
	floatRange :: Double -> (!Int,!Int)
	decodeFloat :: !Double -> (!Integer,!Int)
	encodeFloat :: !Integer -> !Int -> Double
	exponent :: !Double -> Int
	significand :: !Double -> Double
	scaleFloat :: !Int -> !Double -> Double
	isNaN :: !Double -> Bool
	isInfinite :: !Double -> Bool
	isDenormalized :: !Double -> Bool
	isNegativeZero :: !Double -> Bool
	atan2 :: !Double -> !Double -> Double

instance RealFloat Float where
	floatRange :: Float -> (!Int,!Int)
	decodeFloat :: !Float -> (!Integer,!Int)
	encodeFloat :: !Integer -> !Int -> Float
	exponent :: !Float -> Int
	significand :: !Float -> Float
	scaleFloat :: !Int -> !Float -> Float
	isNaN :: !Float -> Bool
	isInfinite :: !Float -> Bool
	isDenormalized :: !Float -> Bool
	isNegativeZero :: !Float -> Bool
	atan2 :: !Float -> !Float -> Float

round_real_to_integer :: !Double -> Integer
truncate_real_to_integer :: !Double -> Integer
floor_real_to_integer :: !Double -> Integer
ceiling_real_to_integer :: !Double -> Integer
proper_integer_fraction_real :: !Double -> (!Integer,!Double)
