definition module PreludeIO where

import PreludeTypes
import PreludeInternalIOError (IOError)

type FilePath=String

instance Show IOError

instance Eq IOError where
	(==) :: !IOError -> !IOError -> Bool
	(/=) :: !IOError -> !IOError -> Bool

ioError :: IOError -> IO a
userError :: String -> IOError
catch :: IO a -> (IOError -> IO a) -> IO a

putChar :: Char -> IO ()
putStr :: String -> IO ()
putStrLn :: String -> IO ()

--print :: Show a => a -> IO ()
print x :== putStrLn (show x)

getChar :: IO Char
getLine :: IO [Char]
getContents :: IO String
interact :: (String -> String) -> IO ()

readFile :: FilePath -> IO String
writeFile :: FilePath -> String -> IO ()
appendFile :: FilePath -> String -> IO ()

--readIO :: Read a => String -> IO a
readIO s :== IO (\w -> readIO_exception_if_error`World (readsPrec `0 s) w)
readIO_exception_if_error`World :: ![(a,[.Char])] -> !*World -> (a,!.World)

--readLn :: Read a => IO a
readLn :== IO (\w -> readLn_f`World (readsPrec `0) w)
readLn_f`World :: !.([Char] -> [(a,[Char])]) -> !*World -> (a,!*World)
