implementation module PreludeInlineFromIntegral where

from StdInt import bitxor
from StdReal import class toReal(..),instance toReal Int

fromIntegral :: (Integral a, Num b) => a -> b
fromIntegral n = fromInteger (toInteger n)

fromIntegral`Int_Int :: !Int -> Int
fromIntegral`Int_Int i = `code inline {
	pop_b 0
}

fromIntegral`Int_Integer :: !Int -> Integer
fromIntegral`Int_Integer i = `code inline {
	pushI 0
	create_array_ INT 0 1
}

fromIntegral`Int_Double :: !Int -> Double
fromIntegral`Int_Double i = `code inline {
	ItoR
}

fromIntegral`Int_Float :: !Int -> Float
fromIntegral`Int_Float i = `code inline {
	ItoR
}

fromIntegral`Integer_Integer :: !Integer -> Integer
fromIntegral`Integer_Integer i = `code inline {
	pop_b 0
}

fromIntegral`Integer_Int :: !Integer -> Int
fromIntegral`Integer_Int {integer_s,integer_a}
	| size integer_a==0
		= integer_s;
		= (integer_a~[0] bitxor integer_s) - integer_s;

fromIntegral`Integer_Double :: !Integer -> Double
fromIntegral`Integer_Double {integer_s,integer_a}
	| size integer_a==0
		= toReal integer_s;
		= integer_a_to_double integer_s integer_a;

fromIntegral`Integer_Float :: !Integer -> Float
fromIntegral`Integer_Float {integer_s,integer_a}
	| size integer_a==0
		= `Float (toReal integer_s);
		= `Float (integer_a_to_double integer_s integer_a);
