definition module PreludeInteger

import PreludeTypes

instance Num Integer where
	(+) :: !Integer !Integer -> Integer
	(-) :: !Integer !Integer -> Integer
	(*) :: !Integer !Integer -> Integer
	abs :: !Integer -> Integer
	signum :: !Integer -> Integer
	negate :: !Integer -> Integer
	fromInteger :: !Integer -> Integer

instance Eq Integer where
	(==) :: !Integer !Integer -> Bool
	(/=) :: !Integer !Integer -> Bool

instance Show Integer where
	show :: !Integer -> [Char]

instance Integral Integer where
	toInteger :: !Integer -> Integer
	quot :: !Integer !Integer -> Integer
	rem :: !Integer !Integer -> Integer
	div :: !Integer !Integer -> Integer
	mod :: !Integer !Integer -> Integer
	quotRem :: !Integer !Integer -> (!Integer,!Integer)
	divMod :: !Integer !Integer -> (!Integer,!Integer)

instance Ord Integer where
	(<) infix  4 :: !Integer !Integer -> Bool
	(<=) infix 4 :: !Integer !Integer -> Bool
	(>=) infix 4 :: !Integer !Integer -> Bool
	(>) infix  4 :: !Integer !Integer -> Bool
	compare :: !Integer !Integer -> Ordering
	min :: !Integer !Integer -> Integer
	max :: !Integer !Integer -> Integer

integer_a_to_double :: !Int !{#Int} -> Real
rational_to_double :: !Rational -> Real

instance Enum Integer where
	toEnum :: !Int -> Integer
	fromEnum :: !Integer -> Int

instance Real Int where
	toRational :: !Int -> Rational

instance Real Integer where
	toRational :: !Integer -> Rational
