definition module PreludeRead where

from PreludeTypes import
	::String,::Integer,::ReadS,::(),::Ordering,::Maybe,::Either,
	class Read

read :: (Read a) => String -> a
		special a=Int; a=Double; a=Float

instance Read Int where
	readsPrec :: Int -> ![Char] -> [(Int,[Char])]

instance Read Integer where
	readsPrec :: Int -> ![Char] -> [(Integer,[Char])]

instance Read Double where
	readsPrec :: Int -> ![Char] -> [(Double,[Char])]

instance Read Float where
	readsPrec :: Int -> ![Char] -> [(Float,[Char])]

instance Read Char where
	readsPrec :: Int -> ![Char] -> [(Char,[Char])]
	readList :: ![Char] -> [([Char],[Char])]

instance Read Bool where
	readsPrec :: Int -> ![Char] -> [(Bool,[Char])]

instance Read () where
	readsPrec :: Int -> ![Char] -> [((),[Char])]

instance Read Ordering where
	readsPrec :: Int -> ![Char] -> [(Ordering,[Char])]

instance (Read a) => Read (Maybe a) where
	readsPrec :: (Read a) => Int -> ![Char] -> [(Maybe a,[Char])]

instance (Read a,Read b) => Read (Either a b) where
	readsPrec :: (Read a,Read b) => Int -> ![Char] -> [(Either a b,[Char])]

instance (Read a) => Read [a]

instance (Read e0,Read e1) =>
		Read (e0,e1) where
		readsPrec :: (Read e0,Read e1) =>
					Int -> ![Char] -> [((e0,e1),[Char])]

instance (Read e0,Read e1,Read e2)
		=> Read (e0,e1,e2) where
		readsPrec :: (Read e0,Read e1,Read e2) =>
					Int -> ![Char] -> [((e0,e1,e2),[Char])]

instance (Read e0,Read e1,Read e2,Read e3)
	=> Read (e0,e1,e2,e3) where
		readsPrec :: (Read e0,Read e1,Read e2,Read e3) =>
					Int -> ![Char] -> [((e0,e1,e2,e3),[Char])]

instance (Read e0,Read e1,Read e2,Read e3,Read e4)
		=> Read (e0,e1,e2,e3,e4) where
		readsPrec :: (Read e0,Read e1,Read e2,Read e3,Read e4) =>
					Int -> ![Char] -> [((e0,e1,e2,e3,e4),[Char])]

instance (Read e0,Read e1,Read e2,Read e3,Read e4,Read e5)
		=> Read (e0,e1,e2,e3,e4,e5) where
		readsPrec :: (Read e0,Read e1,Read e2,Read e3,Read e4,Read e5) =>
					Int -> ![Char] -> [((e0,e1,e2,e3,e4,e5),[Char])]

instance (Read e0,Read e1,Read e2,Read e3,Read e4,Read e5,Read e6)
		=> Read (e0,e1,e2,e3,e4,e5,e6) where
		readsPrec :: (Read e0,Read e1,Read e2,Read e3,Read e4,Read e5,Read e6) =>
					Int -> ![Char] -> [((e0,e1,e2,e3,e4,e5,e6),[Char])]

instance (Read e0,Read e1,Read e2,Read e3,Read e4,Read e5,Read e6,Read e7)
		=> Read (e0,e1,e2,e3,e4,e5,e6,e7) where
		readsPrec :: (Read e0,Read e1,Read e2,Read e3,Read e4,Read e5,Read e6,Read e7) =>
					Int -> ![Char] -> [((e0,e1,e2,e3,e4,e5,e6,e7),[Char])]

instance (Read e0,Read e1,Read e2,Read e3,Read e4,Read e5,Read e6,Read e7,Read e8)
		=> Read (e0,e1,e2,e3,e4,e5,e6,e7,e8) where
		readsPrec :: (Read e0,Read e1,Read e2,Read e3,Read e4,Read e5,Read e6,Read e7,Read e8) =>
					Int -> ![Char] -> [((e0,e1,e2,e3,e4,e5,e6,e7,e8),[Char])]

instance (Read e0,Read e1,Read e2,Read e3,Read e4,Read e5,Read e6,Read e7,Read e8,Read e9)
		=> Read (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9) where
		readsPrec :: (Read e0,Read e1,Read e2,Read e3,Read e4,Read e5,Read e6,Read e7,Read e8,Read e9) =>
					Int -> ![Char] -> [((e0,e1,e2,e3,e4,e5,e6,e7,e8,e9),[Char])]

instance (Read e0,Read e1,Read e2,Read e3,Read e4,Read e5,Read e6,Read e7,Read e8,Read e9,Read e10)
		=> Read (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10) where
		readsPrec :: (Read e0,Read e1,Read e2,Read e3,Read e4,Read e5,Read e6,Read e7,Read e8,Read e9,Read e10) =>
					Int -> ![Char] -> [((e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10),[Char])]

instance (Read e0,Read e1,Read e2,Read e3,Read e4,Read e5,Read e6,Read e7,Read e8,Read e9,Read e10,Read e11)
		=> Read (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11) where
		readsPrec :: (Read e0,Read e1,Read e2,Read e3,Read e4,Read e5,Read e6,Read e7,Read e8,Read e9,Read e10,Read e11) =>
					Int -> ![Char] -> [((e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11),[Char])]

instance (Read e0,Read e1,Read e2,Read e3,Read e4,Read e5,Read e6,Read e7,Read e8,Read e9,Read e10,Read e11,Read e12)
		=> Read (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12) where
		readsPrec :: (Read e0,Read e1,Read e2,Read e3,Read e4,Read e5,Read e6,Read e7,Read e8,Read e9,Read e10,Read e11,Read e12) =>
					Int -> ![Char] -> [((e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12),[Char])]

instance (Read e0,Read e1,Read e2,Read e3,Read e4,Read e5,Read e6,Read e7,Read e8,Read e9,Read e10,Read e11,Read e12,Read e13)
		=> Read (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13) where
		readsPrec :: (Read e0,Read e1,Read e2,Read e3,Read e4,Read e5,Read e6,Read e7,Read e8,Read e9,Read e10,Read e11,Read e12,Read e13) =>
					Int -> ![Char] -> [((e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13),[Char])]

instance (Read e0,Read e1,Read e2,Read e3,Read e4,Read e5,Read e6,Read e7,Read e8,Read e9,Read e10,Read e11,Read e12,Read e13,Read e14)
		=> Read (e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13,e14) where
		readsPrec :: (Read e0,Read e1,Read e2,Read e3,Read e4,Read e5,Read e6,Read e7,Read e8,Read e9,Read e10,Read e11,Read e12,Read e13,Read e14) =>
					Int -> ![Char] -> [((e0,e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12,e13,e14),[Char])]

lex :: !String -> [(String,String)]
readParen :: !Bool -> ReadS a -> ReadS a

skip_spaces`` :: ![(a,String)] -> [(a,String)]
read_close` :: ![(a,String)] -> [(a,String)]
not_begins_with_id_char` :: !String -> Bool
