module System.Exit (
	ExitCode(..),exitWith
  ) where

import StdMisc (abort)

data ExitCode = ExitSuccess | ExitFailure Int deriving (Eq, Ord, Read, Show)

exitWith :: !ExitCode -> IO a
exitWith ExitSuccess = IO (exitWithW 0)
exitWith (ExitFailure n) = IO (exitWithW n)

exitWithW :: !Int -> !*World -> (!a,!*World)
exitWithW r w
	#! a = seq (store_int return_code_p r) (abort `"")
	= (a,w)

return_code_p :: Int
return_code_p = `code {
	pushLc return_code
}

store_int :: !Int -> !Int -> Int
store_int p v = `code {
	:store_int_0
	|	movl	%eax,(%ebx)
	instruction 137
	instruction 3
	:store_int_1
	update_b 0 1
	pop_b 1
}

